#
# Copyright 1998 - 2010 Double Precision, Inc.  See COPYING for
# distribution information.


#
#  Need to version-upgrade RH builds due to different directory locations.
#

%define is_not_mandrake %(test ! -e /etc/mandrake-release && echo 1 || echo 0)

%if 0%{!?dist:1}
%if %is_not_mandrake
%define courier_release %(release="`rpm -q --queryformat='.%{VERSION}' redhat-release 2>/dev/null`" ; if test $? != 0 ; then release="`rpm -q --queryformat='.%{VERSION}' fedora-release 2>/dev/null`" ; if test $? != 0 ; then release="" ; fi ; fi ; echo "$release")
%else
%define courier_release mdk
%endif
%else
%define courier_release %{nil}
%endif

%define _missing_doc_files_terminate_build 1
%define _unpackaged_files_terminate_build 1

%{expand:%%define apachedir %(if test -d /home/httpd ; then echo /home/httpd ; else echo /var/www ; fi)}

%define	cgibindir		%{apachedir}/cgi-bin
%define imagedir		%{apachedir}/html/webmail
%define	imageurl		/webmail

%define	cacheowner		bin
%define cachedir		%{_localstatedir}/webmail-logincache

%{expand:%%define initdir %(if test -d /etc/init.d/. ; then echo /etc/init.d ; else echo /etc/rc.d/init.d ; fi)}

Summary: SqWebMail - Maildir Webmail CGI client.
Name: sqwebmail
Version: 5.6.0
Release: 1%{?dist}%{courier_release}
License: GPL
Group: Applications/Mail
Source: http://download.sourceforge.net/courier/sqwebmail-5.6.0.tar.bz2
Url: http://www.courier-mta.org/sqwebmail
BuildRoot: %{_tmppath}/sqwebmail-install
Requires: /bin/systemctl /etc/cron.hourly expect
Requires: %(which gpg >/dev/null 2>/dev/null && echo 'gnupg >= 1.0.5' && exit 0; echo gnupg2)

%if %is_not_mandrake
Requires: %{cgibindir}
%endif
Obsoletes: %{name}-mysql
Obsoletes: %{name}-pgsql

BuildRequires: rpm >= 4.0.2 fileutils grep perl
BuildRequires: %(which gpg >/dev/null 2>/dev/null && echo 'gnupg >= 1.0.5' && exit 0; echo gnupg2)
BuildRequires: openldap-devel courier-authlib-devel >= 0.55
BuildRequires: /etc/mime.types
BuildRequires: libidn-devel

%description
SqWebMail is a Webmail CGI for Maildir mailboxes.

%package ldap
Group: Applications/Mail
Summary: LDAP address book hook for SqWebMail
Requires: %{name} = 0:%{version}-%{release}

%description ldap
This package installes the SqWebMail LDAP address book lookup module.

%define _prefix /usr/lib/sqwebmail
%define _sysconfdir %{_prefix}/etc
%define _mandir %{_prefix}/man

%define scriptdir %{_datadir}/sqwebmail
%define htmldir %{_datadir}/sqwebmail/html

%prep
%setup -q
PATH=/usr/bin:$PATH %configure \
	--enable-cgibindir=%{cgibindir} \
	--enable-imagedir=%{imagedir} \
	--enable-imageurl=%{imageurl} \
	--with-cachedir=%{cachedir} \
	--with-cacheowner=%{cacheowner} \
	%{?xflags: %{xflags}}


#
#  --sysconfdir needed for RH 7.x
#

%build
%{__make} %{_smp_mflags}
%{__make} check
%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT
%{__mkdir} -p $RPM_BUILD_ROOT/etc/pam.d
%{__install} -m 0444 sqwebmail/webmail.authpam $RPM_BUILD_ROOT/etc/pam.d/webmail
%{__install} -m 0444 sqwebmail/webmail.authpam $RPM_BUILD_ROOT/etc/pam.d/calendar

%{__rm} $RPM_BUILD_ROOT%{htmldir}/en || exit 1
# Drop the soft link -> en_us, this is taken care of by post script.

%{__mkdir} -p $RPM_BUILD_ROOT/etc/cron.hourly
%{__cat} >$RPM_BUILD_ROOT/etc/cron.hourly/sqwebmail-cron-cleancache <<EOF
#!/bin/sh

su - %{cacheowner} -s /bin/sh -c %{scriptdir}/cleancache.pl
EOF

#
# Red Hat /etc/profile.d scripts
#

%{__mkdir} -p $RPM_BUILD_ROOT/etc/profile.d
%{__cat} >$RPM_BUILD_ROOT/etc/profile.d/sqwebmail.sh <<EOF
if echo "\$MANPATH" | tr ':' '\012' | fgrep -qx %{_mandir}
then
	:
else
	MANPATH="%{_mandir}:\$MANPATH"
	export MANPATH

	if test -w /etc
	then
		PATH="%{_sbindir}:\$PATH"
	fi
	export PATH
fi
EOF

%{__cat} >$RPM_BUILD_ROOT/etc/profile.d/sqwebmail.csh <<EOF

if ( \$?MANPATH ) then
	true
else
	setenv MANPATH ""
endif

echo "\$MANPATH" | tr ':' '\012' | fgrep -qx %{_mandir}

if ( \$? ) then
	true
else
	setenv MANPATH "%{_mandir}:\$MANPATH"
	test -w /etc
	if ( \$? ) then
		true
        else
		setenv PATH "%{_sbindir}:\$PATH"
	endif
endif
EOF

#
# Red Hat init.d file
#

%{__mkdir} -p $RPM_BUILD_ROOT/lib/systemd/system

%{__cat} >$RPM_BUILD_ROOT/lib/systemd/system/sqwebmail.service <<EOF
[Unit]
Description=SqWebMail
Wants=network.target
Wants=courier-authlib.service
Wants=mail-transfer-agent.target
After=network.target
After=courier-authlib.service
After=mail-transfer-agent.target

[Install]
WantedBy=multi-user.target

[Service]
Type=forking
RemainAfterExit=true
ExecStart=%{_libexecdir}/sqwebmaild.rc start
ExecStop=%{_libexecdir}/sqwebmaild.rc stop
EOF

%{__cp} sysconftool $RPM_BUILD_ROOT%{scriptdir}/sysconftool

%{__cp} pcp/README.html pcp_README.html

. pcp/uids
echo '%attr(-, ' "$localcacheowner, $mailgroup) $calendardir" >filelist

(
courierauthconfig --configfiles >configtmp || exit 1
. ./configtmp
echo '%attr(-, '"$mailuser, $mailgroup" ') %{_libexecdir}' >>filelist
) || exit 1

ls $RPM_BUILD_ROOT%{scriptdir} | grep -v ldapsearch | sed 's:^:%attr(555, root, root) %{scriptdir}/:' >>filelist
%post

test -d %{htmldir}/en || ln -fs en-us %{htmldir}/en

if test -f %{initdir}/sqwebmail
then
	/sbin/chkconfig --del sqwebmail
	/bin/systemctl stop sqwebmail.service
fi

%{scriptdir}/sysconftool %{_sysconfdir}/*.dist >/dev/null

/bin/systemctl daemon-reload || :
/bin/systemctl enable sqwebmail.service &> /dev/null || :

%preun

if test "$1" = 0
then
	/bin/systemctl stop sqwebmail.service
	/bin/systemctl disable sqwebmail.service

fi

%postun
test -d %{htmldir}/en || %{__rm} -f %{htmldir}/en

/bin/systemctl daemon-reload || :

if test "$1" != 0
then
	/bin/systemctl try-restart sqwebmail.service || :
fi
%files -f filelist
%defattr(-, root, bin)
%dir %{_prefix}
%if "%{_prefix}" != "%{_exec_prefix}"
%dir %{_exec_prefix}
%endif

%attr(555, root, root) %dir %{scriptdir}
%dir %{_sysconfdir}
%{_sysconfdir}/*.dist

%{cgibindir}/*
%{imagedir}
%{_sbindir}
%{_mandir}

%attr(644, root, root) /lib/systemd/system/*

%attr(700, %{cacheowner}, bin) %{cachedir}
%attr(644, root, root) %config(noreplace) /etc/pam.d/*

%attr(755, bin, bin) /etc/cron.hourly/sqwebmail-cron-cleancache
%attr(755, bin, bin) /etc/profile.d/sqwebmail.sh
%attr(755, bin, bin) /etc/profile.d/sqwebmail.csh

%attr(-, bin, bin) %doc AUTHORS sqwebmail/BUGS COPYING INSTALL NEWS README sqwebmail/SECURITY sqwebmail/TODO gpglib/README.html
%attr(-, bin, bin) %doc sqwebmail/BUGS.html INSTALL.html NEWS README.html sqwebmail/SECURITY.html sqwebmail/TODO.html sqwebmail/ChangeLog pcp_README.html
%attr(-, bin, bin) %doc maildir/README*.html

%files ldap
%attr(755, root, root) %{scriptdir}/ldapsearch

%clean
%{__rm} -rf $RPM_BUILD_ROOT
